/*
 *  sample_triangle_external_field.cpp
 *  
 *
 *  Created by Damian Farnell on 11/04/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#define _USR_PARAMETER_   // may be defined in USR_FILE  see solve.C
#define UseAlpha 1
#define StartAlpha (M_PI/6.0)
#define StepAlpha  (0.001*M_PI)
#define SearchAlphaMin 2
double usr_parameter(int bonds, double alpha)
{
  // condition for triangular AF in external field: both model states
    if (bonds==1 || bonds==2) return alpha;
      return 1.0;
}

double usr_angle(int bonds, int term13, double *alpha, int numalpha)
{
  // add your model specifique parameter here! 
  //  tdelta * H1 + H2 + H3 + ...
  // model state 1 for triangle and kagome lattices in external fields. (low field limit).
  // now for the q=0 kagome state also.
  // Jun08 Joerg: alpha, beta, gamma replaced by alpha[0..2]
  
  double returnValue, beta2;
  beta2=alpha[2];  // was gamma, not used?
  returnValue=0.0;
  if (numalpha!=1) ERR("wrong number of free angles alpha");

  if (bonds == 1) {
	  
    // external field term in H on sites 2 and 3
	  
    if (term13==10) returnValue=      sin(alpha[0]); // z
    if (term13==11) returnValue=  0.5*cos(alpha[0]); // -
    if (term13==13) returnValue=  0.5*cos(alpha[0]); // +

  } else if (bonds == 2) {
	
    // external field term in H on site 1

    if (term13==10) returnValue= -1.0; // z
	
  } if (bonds == 3) {

    // nearest-neighbour bonds in H between sites 1->2 and 3->1 (directional)

    if (term13==1) returnValue=     -sin(alpha[0]);  // zz
    if (term13==2) returnValue= -0.5*cos(alpha[0]);  // z+ sign correct for directional 1->2 and 3->1
    if (term13==3) returnValue= -0.5*cos(alpha[0]);  // z- sign correct for directional 1->2 and 3->1
    if (term13==4) returnValue=  0.5*cos(alpha[0]);  // +z sign correct for directional 1->2 and 3->1
    if (term13==5) returnValue=  0.5*cos(alpha[0]);  // -z sign correct for directional 1->2 and 3->1
    if (term13==6) returnValue= 0.25*( 1.0-sin(alpha[0])); // +-
    if (term13==7) returnValue= 0.25*( 1.0-sin(alpha[0])); // -+
    if (term13==8) returnValue= 0.25*(-1.0-sin(alpha[0])); // ++
    if (term13==9) returnValue= 0.25*(-1.0-sin(alpha[0])); // --
	  
  } else if (bonds == 4) {
	
    // nearest-neighbour bonds in H between sites 2->3 (directional)

    if (term13==1) returnValue=     -cos(2*alpha[0]); // zz
    if (term13==2) returnValue= -0.5*sin(2*alpha[0]); // z+ sign correct for directional 2->3 
    if (term13==3) returnValue= -0.5*sin(2*alpha[0]); // z- sign correct for directional 2->3 
    if (term13==4) returnValue=  0.5*sin(2*alpha[0]); // +z sign correct for directional 2->3 
    if (term13==5) returnValue=  0.5*sin(2*alpha[0]); // -z sign correct for directional 2->3 
    if (term13==6) returnValue= 0.25*( 1.0-cos(2*alpha[0])); // +-
    if (term13==7) returnValue= 0.25*( 1.0-cos(2*alpha[0])); // -+
    if (term13==8) returnValue= 0.25*(-1.0-cos(2*alpha[0])); // ++
    if (term13==9) returnValue= 0.25*(-1.0-cos(2*alpha[0])); // --
  } 
	
  return returnValue;
}

/*
 *  sample_triangle_external_field_expectationl_1.cpp
 *  
 *
 *  Created by Damian Farnell on 11/05/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

double usr_exp_angle(int expect, int term13, double *alpha, int numaplha)
{
    // add your model specifique parameter here! 
    //  tdelta * H1 + H2 + H3 + ...
	// model state 1 for triangle and kagome lattices in external fields. (low field limit).
    // now for the q=0 kagome state also.


    double returnValue,beta2;
	beta2=alpha[2];
	
	returnValue=0.0;
	if (expect == 1 || expect == 2) { // DJJF Jun08
	  
	  // external field term in H on sites 2 and 3
	  
          if (term13==10) returnValue=    sin(alpha[0]);
          if (term13==11) returnValue=0.5*cos(alpha[0]);
          if (term13==13) returnValue=0.5*cos(alpha[0]);

	} else if (expect == 3) {
	
	  // external field term in H on site 1

	  if (term13==10) returnValue=-1.0;
	
    } 
	
    return returnValue;
}
